c      implicit none
c      real*8 u, s
c      real*8 cmBremI2
c      u = 1.e-5
c      do while (u .lt. 300.) 
c         s = cmBremI2(u)
c         write(*,*) u, s
c         u = u * 10.**.1
c      enddo
c      end
	real*8 function cmBremI2(u)
c          This program give approximate integral value of
c          v^2 2zeta K(2zeta) dv from v = 0 to 1.
c          Original integaral is done by inteSpec1.f and
c          result was approximated by polynomials.
c
	implicit none
	real*8  u  ! input. Upsilon
c       function value  ! output. integral value 

        real*8 lu, ans
	if(u .lt. 3.16d-5) then
                ans = ans * u**2 *  3.9257
	elseif(u .lt.  1.584d-2) then
		lu = log(u)
		ans = ((-0.5219002E-02 *lu - 0.1067265)* lu     
     *          -0.7421499 )*lu  -0.7647935     
                ans = ans * u**2 *  3.9257
        elseif(u .lt. 1.) then
		lu = log(u)
		ans = ((0.1696074E-01*lu + 0.1197285)*lu
     *         +  0.1439367E-01)*lu  +   0.5595450E-01 
                ans = ans * u**2 *  3.9257
	elseif(u .lt. 300.) then
		lu = log(u)

		ans = (( 0.2566103E-02*lu -0.3215703E-01 )*lu
     *          +  0.9286942E-01)*lu + 0.1500733     

	else	
	        stop 55555
        endif	
        cmBremI2 = ans
	end
